Index: ultimate_cart/veronica/FT832.v
===================================================================
--- ultimate_cart/veronica/FT832.v	(revision 684)
+++ ultimate_cart/veronica/FT832.v	(revision 685)
@@ -2372,7 +2527,6 @@
                 end
                 load_what <= `LOAD_70;
                 retstate <= CALC;
-                state <= LOAD_MAC2;
                 bank_wrap <= !m832;
             end
         `STA_ZPX:
@@ -2379,12 +2533,12 @@
             begin
                 inc_pc(24'd2);
                 wadr <= zpx_address;
+                next_state(STORE1);
                 if (!sop) begin
                     if (m32) s32 <= TRUE;
                     else if (m16) s16 <= TRUE;
                 end
                 store_what <= `STW_ACC70;
-                state <= STORE1;
                 bank_wrap <= !m832;
             end
         `STY_ZPX:
@@ -2391,12 +2545,12 @@
             begin
                 inc_pc(24'd2);
                 wadr <= zpx_address;
+                next_state(STORE1);
                 if (!sop) begin
                     if (xb32) s32 <= TRUE;
                     else if (xb16) s16 <= TRUE;
                 end
                 store_what <= `STW_Y70;
-                state <= STORE1;
                 bank_wrap <= !m832;
             end
         `STZ_ZPX:
@@ -2403,12 +2557,12 @@
             begin
                 inc_pc(24'd2);
                 wadr <= zpx_address;
+                next_state(STORE1);
                 if (!sop) begin
                     if (m32) s32 <= TRUE;
                     else if (m16) s16 <= TRUE;
                 end
                 store_what <= `STW_Z70;
-                state <= STORE1;
                 bank_wrap <= !m832;
             end
         // Handle zp,y
@@ -2416,13 +2570,12 @@
             begin
                 inc_pc(24'd2);
                 radr <= zpy_address;
-                data_read(zpy_address,1);
+                next_state(LOAD_MAC1);
                 if (!sop) begin
                     if (xb32) s32 <= TRUE;
                     else if (xb16) s16 <= TRUE;
                 end
                 load_what <= `LOAD_70;
-                state <= LOAD_MAC2;
                 retstate <= ssm ? SSM1 : IFETCH;
                 bank_wrap <= !m832;
             end
@@ -2430,12 +2583,12 @@
             begin
                 inc_pc(24'd2);
                 wadr <= zpy_address;
+                next_state(STORE1);
                 if (!sop) begin
                     if (xb32) s32 <= TRUE;
                     else if (xb16) s16 <= TRUE;
                 end
                 store_what <= `STW_X70;
-                state <= STORE1;
                 bank_wrap <= !m832;
             end
 		// Handle (zp,x)
@@ -2443,7 +2596,6 @@
             begin
                 inc_pc(24'd2);
                 radr <= zpx_address;
-                data_read(zpx_address,1);
                 mxb16 <= m16;
                 mxb32 <= m32;
                 load_what <= `IA_70;
@@ -2450,16 +2602,16 @@
                 state <= LOAD_MAC2;
                 retstate <= ssm ? SSM1 : IFETCH;
                 bank_wrap <= !m832;
+                data_read(zpx_address,1);
             end
         `ADC_IX,`SBC_IX,`AND_IX,`ORA_IX,`EOR_IX,`CMP_IX,`STA_IX:
             begin
                 inc_pc(24'd2);
                 radr <= zpx_address;
-                data_read(zpx_address,1);
                 mxb16 <= m16;
                 mxb32 <= m32;
                 load_what <= `IA_70;
-                state <= LOAD_MAC2;
+                state <= LOAD_MAC1;
                 retstate <= CALC;
                 bank_wrap <= !m832;
             end
@@ -2468,12 +2620,11 @@
             begin
                 inc_pc(24'd2);
                 radr <= zp_address;
-                data_read(zp_address,1);
                 mxb16 <= m16;
                 mxb32 <= m32;
                 isIY <= `TRUE;
                 load_what <= `IA_70;
-                state <= LOAD_MAC2;
+                state <= LOAD_MAC1;
                 retstate <= ssm ? SSM1 : IFETCH;
                 bank_wrap <= !m832;
             end
@@ -2481,12 +2632,11 @@
             begin
                 inc_pc(24'd2);
                 radr <= zp_address;
-                data_read(zp_address,1);
                 mxb16 <= m16;
                 mxb32 <= m32;
                 isIY <= `TRUE;
                 load_what <= `IA_70;
-                state <= LOAD_MAC2;
+                state <= LOAD_MAC1;
                 retstate <= CALC;
                 bank_wrap <= !m832;
             end
@@ -2494,9 +2644,11 @@
         `LDA_DSP:
             begin
                 inc_pc(24'd2);
+`ifdef SUPPORT_SEG                
                 seg <= ss_base;
                 lmt <= ss_limit;
                 mem_wr <= ss_wr;
+`endif           
                 radr <= dsp_address;
                 mxb16 <= m16;
                 mxb32 <= m32;
@@ -2512,9 +2664,11 @@
             begin
                 inc_pc(24'd2);
                 radr <= dsp_address;
+`ifdef SUPPORT_SEG                
                 seg <= ss_base;
                 lmt <= ss_limit;
                 mem_wr <= ss_wr;
+`endif
                 mxb16 <= m16;
                 mxb32 <= m32;
                 if (!sop) begin
@@ -2528,9 +2682,11 @@
         `STA_DSP:
             begin
                 inc_pc(24'd2);
+`ifdef SUPPORT_SEG                
                 seg <= ss_base;
                 lmt <= ss_limit;
                 mem_wr <= ss_wr;
+`endif                
                 radr <= dsp_address;
                 wadr <= dsp_address;
                 if (!sop) begin
@@ -2544,10 +2700,12 @@
 		`LDA_DSPIY:
             begin
                 inc_pc(24'd2);
+`ifdef SUPPORT_SEG                
                 seg <= ss_base;
                 lmt <= ss_limit;
+                mem_wr <= ss_wr;
+`endif                
                 radr <= dsp_address;
-                mem_wr <= ss_wr;
                 mxb16 <= m16;
                 mxb32 <= m32;
                 isIY <= `TRUE;
@@ -2559,9 +2717,11 @@
             begin
                 inc_pc(24'd2);
                 radr <= dsp_address;
+`ifdef SUPPORT_SEG                
                 seg <= ss_base;
                 lmt <= ss_limit;
                 mem_wr <= ss_wr;
+`endif                
                 mxb16 <= m16;
                 mxb32 <= m32;
                 isIY <= `TRUE;
@@ -2574,12 +2734,15 @@
 	   `LDA_XDSPIY:
             begin
                inc_pc(24'd2);
+`ifdef SUPPORT_SEG               
                seg <= ss_base;
                lmt <= ss_limit;
                mem_wr <= ss_wr;
+`endif               
                radr <= dsp_address;
                mxb16 <= m16;
                mxb32 <= m32;
+               isI32 <= `TRUE;
                isIY32 <= `TRUE;
                load_what <= `IA_70;
                state <= LOAD_MAC1;
@@ -2588,12 +2751,15 @@
        `ADC_XDSPIY,`SBC_XDSPIY,`CMP_XDSPIY,`ORA_XDSPIY,`AND_XDSPIY,`EOR_XDSPIY,`STA_XDSPIY:
             begin
                 inc_pc(24'd2);
+`ifdef SUPPORT_SEG                
                 seg <= ss_base;
                 lmt <= ss_limit;
                 mem_wr <= ss_wr;
+`endif                
                 radr <= dsp_address;
                 mxb16 <= m16;
                 mxb32 <= m32;
+                isI32 <= TRUE;
                 isIY32 <= `TRUE;
                 load_what <= `IA_70;
                 state <= LOAD_MAC1;
@@ -2605,12 +2771,12 @@
             begin
                 inc_pc(24'd2);
                 radr <= zp_address;
-                data_read(zp_address,1);
                 mxb16 <= m16;
                 mxb32 <= m32;
+                isI24 <= `TRUE;
                 isIY24 <= `TRUE;
                 load_what <= `IA_70;
-                state <= LOAD_MAC2;
+                state <= LOAD_MAC1;
                 retstate <= ssm ? SSM1 : IFETCH;
             end
         `ADC_IYL,`SBC_IYL,`AND_IYL,`ORA_IYL,`EOR_IYL,`CMP_IYL,`STA_IYL:
@@ -2617,12 +2783,12 @@
             begin
                 inc_pc(24'd2);
                 radr <= zp_address;
-                data_read(zp_address,1);
                 mxb16 <= m16;
                 mxb32 <= m32;
+                isI24 <= `TRUE;
                 isIY24 <= `TRUE;
                 load_what <= `IA_70;
-                state <= LOAD_MAC2;
+                state <= LOAD_MAC1;
                 retstate <= CALC;
             end
 `ifdef SUPPORT_NEW_INSN
@@ -2631,12 +2797,12 @@
             begin
                 inc_pc(24'd2);
                 radr <= zp_address;
-                data_read(zp_address,1);
                 mxb16 <= m16;
                 mxb32 <= m32;
+                isI32 <= `TRUE;
                 isIY32 <= `TRUE;
                 load_what <= `IA_70;
-                state <= LOAD_MAC2;
+                state <= LOAD_MAC1;
                 retstate <= ssm ? SSM1 : IFETCH;
             end
         `ADC_XIYL,`SBC_XIYL,`AND_XIYL,`ORA_XIYL,`EOR_XIYL,`CMP_XIYL,`STA_XIYL:
@@ -2643,12 +2809,12 @@
             begin
                 inc_pc(24'd2);
                 radr <= zp_address;
-                data_read(zp_address,1);
                 mxb16 <= m16;
                 mxb32 <= m32;
+                isI32 <= `TRUE;
                 isIY32 <= `TRUE;
                 load_what <= `IA_70;
-                state <= LOAD_MAC2;
+                state <= LOAD_MAC1;
                 retstate <= CALC;
             end
 `endif
@@ -2658,11 +2824,10 @@
                 inc_pc(24'd2);
                 isI24 <= `TRUE;
                 radr <= zp_address;
-                data_read(zp_address,1);
                 mxb16 <= m16;
                 mxb32 <= m32;
                 load_what <= `IA_70;
-                state <= LOAD_MAC2;
+                state <= LOAD_MAC1;
                 retstate <= ssm ? SSM1 : IFETCH;
                 bank_wrap <= !m832;
             end
@@ -2671,11 +2836,10 @@
                 inc_pc(24'd2);
                 isI24 <= `TRUE;
                 radr <= zp_address;
-                data_read(zp_address,1);
                 mxb16 <= m16;
                 mxb32 <= m32;
                 load_what <= `IA_70;
-                state <= LOAD_MAC2;
+                state <= LOAD_MAC1;
                 retstate <= CALC;
                 bank_wrap <= !m832;
             end
@@ -2686,11 +2850,10 @@
                 inc_pc(24'd2);
                 isI32 <= `TRUE;
                 radr <= zp_address;
-                data_read(zp_address,1);
                 mxb16 <= m16;
                 mxb32 <= m32;
                 load_what <= `IA_70;
-                state <= LOAD_MAC2;
+                state <= LOAD_MAC1;
                 retstate <= ssm ? SSM1 : IFETCH;
                 bank_wrap <= !m832;
             end
@@ -2699,11 +2862,10 @@
                 inc_pc(24'd2);
                 isI32 <= `TRUE;
                 radr <= zp_address;
-                data_read(zp_address,1);
                 mxb16 <= m16;
                 mxb32 <= m32;
                 load_what <= `IA_70;
-                state <= LOAD_MAC2;
+                state <= LOAD_MAC1;
                 retstate <= CALC;
                 bank_wrap <= !m832;
             end
@@ -2713,11 +2875,10 @@
             begin
                 inc_pc(24'd2);
                 radr <= zp_address;
-                data_read(zp_address,1);
                 mxb16 <= m16;
                 mxb32 <= m32;
                 load_what <= `IA_70;
-                state <= LOAD_MAC2;
+                state <= LOAD_MAC1;
                 retstate <= ssm ? SSM1 : IFETCH;
                 bank_wrap <= !m832;
             end
@@ -2725,11 +2886,10 @@
             begin
                 inc_pc(24'd2);
                 radr <= zp_address;
-                data_read(zp_address,1);
                 mxb16 <= m16;
                 mxb32 <= m32;
                 load_what <= `IA_70;
-                state <= LOAD_MAC2;
+                state <= LOAD_MAC1;
                 retstate <= CALC;
                 bank_wrap <= !m832;
             end
@@ -2740,7 +2900,7 @@
                 mxb16 <= m16;
                 mxb32 <= m32;
                 radr <= abs_address;
-                data_read(abs_address,1);
+                next_state(LOAD_MAC1);
                 if (!sop) begin
                     if (m32) s32 <= TRUE;
                     else if (m16) s16 <= TRUE;
@@ -2747,7 +2907,6 @@
                 end
                 load_what <= `LOAD_70;
                 retstate <= ssm ? SSM1 : IFETCH;
-                state <= LOAD_MAC2;
             end
         `LDX_ABS,`LDY_ABS:
             begin
@@ -2755,13 +2914,12 @@
                 mxb16 <= xb16;
                 mxb32 <= xb32;
                 radr <= abs_address;
-                data_read(abs_address,1);
+                next_state(LOAD_MAC1);
                 if (!sop) begin
                     if (xb32) s32 <= TRUE;
                     else if (xb16) s16 <= TRUE;
                 end
                 load_what <= `LOAD_70;
-                state <= LOAD_MAC2;
                 retstate <= ssm ? SSM1 : IFETCH;
             end
         `ADC_ABS,`SBC_ABS,`AND_ABS,`ORA_ABS,`EOR_ABS,`CMP_ABS,
@@ -2771,7 +2929,7 @@
                 inc_pc(24'd3);
                 radr <= abs_address;
                 wadr <= abs_address;
-                data_read(abs_address,1);
+                next_state(LOAD_MAC1);
                 mxb16 <= m16;
                 mxb32 <= m32;
                 if (!sop) begin
@@ -2779,7 +2937,6 @@
                     else if (m16) s16 <= TRUE;
                 end
                 load_what <= `LOAD_70;
-                state <= LOAD_MAC2;
                 retstate <= CALC;
             end
         `CPX_ABS,`CPY_ABS:
@@ -2786,7 +2943,7 @@
             begin
                 inc_pc(24'd3);
                 radr <= abs_address;
-                data_read(abs_address,1);
+                next_state(LOAD_MAC1);
                 mxb16 <= xb16;
                 mxb32 <= xb32;
                 if (!sop) begin
@@ -2794,7 +2951,6 @@
                     else if (xb16) s16 <= TRUE;
                 end
                 load_what <= `LOAD_70;
-                state <= LOAD_MAC2;
                 retstate <= CALC;
             end
         `STA_ABS:
@@ -2804,13 +2960,12 @@
                 mxb32 <= m32;
                 radr <= abs_address;
                 wadr <= abs_address;
+                next_state(STORE1);
                 if (!sop) begin
                     if (m32) s32 <= TRUE;
                     else if (m16) s16 <= TRUE;
                 end
                 store_what <= `STW_ACC70;
-                data_write(abs_address,acc[7:0],1);
-                state <= STORE2;
             end
         `STX_ABS:
             begin
@@ -2819,13 +2974,12 @@
                 mxb32 <= xb32;
                 radr <= abs_address;
                 wadr <= abs_address;
+                next_state(STORE1);
                 if (!sop) begin
                     if (xb32) s32 <= TRUE;
                     else if (xb16) s16 <= TRUE;
                 end
                 store_what <= `STW_X70;
-                data_write(abs_address,x[7:0],1);
-                state <= STORE2;
             end    
         `STY_ABS:
             begin
@@ -2834,13 +2988,12 @@
                 mxb32 <= xb32;
                 radr <= abs_address;
                 wadr <= abs_address;
+                next_state(STORE1);
                 if (!sop) begin
                     if (xb32) s32 <= TRUE;
                     else if (xb16) s16 <= TRUE;
                 end
                 store_what <= `STW_Y70;
-                data_write(abs_address,y[7:0],1);
-                state <= STORE2;
             end
         `STZ_ABS:
             begin
@@ -2849,13 +3002,12 @@
                 mxb32 <= m32;
                 radr <= abs_address;
                 wadr <= abs_address;
+                next_state(STORE1);
                 if (!sop) begin
                     if (m32) s32 <= TRUE;
                     else if (m16) s16 <= TRUE;
                 end
                 store_what <= `STW_Z70;
-                data_write(abs_address,8'h00,1);
-                state <= STORE2;
             end
 `ifdef SUPPORT_NEW_INSN
 		// Handle xlabs
@@ -2865,13 +3017,12 @@
                 mxb16 <= m16;
                 mxb32 <= m32;
                 radr <= xal_address;
-                data_read(xal_address,1);
+                next_state(LOAD_MAC1);
                 if (!sop) begin
                     if (m32) s32 <= TRUE;
                     else if (m16) s16 <= TRUE;
                 end
                 load_what <= `LOAD_70;
-                state <= LOAD_MAC2;
                 retstate <= ssm ? SSM1 : IFETCH;
             end
         `LDX_XABS,`LDY_XABS:
@@ -2880,13 +3031,12 @@
                 mxb16 <= xb16;
                 mxb32 <= xb32;
                 radr <= xal_address;
-                data_read(xal_address,1);
+                next_state(LOAD_MAC1);
                 if (!sop) begin
                     if (xb32) s32 <= TRUE;
                     else if (xb16) s16 <= TRUE;
                 end
                 load_what <= `LOAD_70;
-                state <= LOAD_MAC2;
                 retstate <= ssm ? SSM1 : IFETCH;
             end
         `ADC_XABS,`SBC_XABS,`AND_XABS,`ORA_XABS,`EOR_XABS,`CMP_XABS,
@@ -2896,7 +3046,7 @@
                 inc_pc(24'd5);
                 radr <= xal_address;
                 wadr <= xal_address;
-                data_read(xal_address,1);
+                next_state(LOAD_MAC1);
                 mxb16 <= m16;
                 mxb32 <= m32;
                 if (!sop) begin
@@ -2904,7 +3054,6 @@
                     else if (m16) s16 <= TRUE;
                 end
                 load_what <= `LOAD_70;
-                state <= LOAD_MAC2;
                 retstate <= CALC;
             end
         `CPX_XABS,`CPY_XABS:
@@ -2911,7 +3060,7 @@
             begin
                 inc_pc(24'd5);
                 radr <= xal_address;
-                data_read(xal_address,1);
+                next_state(LOAD_MAC1);
                 mxb16 <= xb16;
                 mxb32 <= xb32;
                 if (!sop) begin
@@ -2919,7 +3068,6 @@
                     else if (xb16) s16 <= TRUE;
                 end
                 load_what <= `LOAD_70;
-                state <= LOAD_MAC2;
                 retstate <= CALC;
             end
         `STA_XABS:
@@ -2929,13 +3077,12 @@
                 mxb32 <= m32;
                 radr <= xal_address;
                 wadr <= xal_address;
+                next_state(STORE1);
                 if (!sop) begin
                     if (m32) s32 <= TRUE;
                     else if (m16) s16 <= TRUE;
                 end
                 store_what <= `STW_ACC70;
-                data_write(xal_address,acc[7:0],1);
-                state <= STORE2;
             end
         `STX_XABS:
             begin
@@ -2944,13 +3091,12 @@
                 mxb32 <= xb32;
                 radr <= xal_address;
                 wadr <= xal_address;
+                next_state(STORE1);
                 if (!sop) begin
                     if (xb32) s32 <= TRUE;
                     else if (xb16) s16 <= TRUE;
                 end
                 store_what <= `STW_X70;
-                data_write(xal_address,x[7:0],1);
-                state <= STORE2;
             end    
         `STY_XABS:
             begin
@@ -2959,13 +3105,12 @@
                 mxb32 <= xb32;
                 radr <= xal_address;
                 wadr <= xal_address;
+                next_state(STORE1);
                 if (!sop) begin
                     if (xb32) s32 <= TRUE;
                     else if (xb16) s16 <= TRUE;
                 end
                 store_what <= `STW_Y70;
-                data_write(xal_address,y[7:0],1);
-                state <= STORE2;
             end
         `STZ_XABS:
             begin
@@ -2972,14 +3117,26 @@
                 inc_pc(24'd5);
                 radr <= xal_address;
                 wadr <= xal_address;
+                next_state(STORE1);
                 if (!sop) begin
                     if (m32) s32 <= TRUE;
                     else if (m16) s16 <= TRUE;
                 end
                 store_what <= `STW_Z70;
-                data_write(xal_address,8'h00,1);
-                state <= STORE2;
             end
+        `BMT_XABS,`BMS_XABS,`BMC_XABS:
+            begin
+                inc_pc(24'd5);
+                mxb16 <= m16;
+                mxb32 <= m32;
+                radr <= {3'd0,acc[31:3]} + xal_address;
+                wadr <= {3'd0,acc[31:3]} + xal_address;
+                next_state(LOAD_MAC1);
+                s32 <= FALSE;
+                s16 <= FALSE;
+                load_what <= `LOAD_70;
+                retstate <= CALC;
+            end
 `endif
         // Handle abs,x
         `LDA_ABSX:
@@ -2988,13 +3145,12 @@
                 mxb16 <= m16;
                 mxb32 <= m32;
                 radr <= absx_address;
-                data_read(absx_address,1);
+                next_state(LOAD_MAC1);
                 if (!sop) begin
                     if (m32) s32 <= TRUE;
                     else if (m16) s16 <= TRUE;
                 end
                 load_what <= `LOAD_70;
-                state <= LOAD_MAC2;
                 retstate <= ssm ? SSM1 : IFETCH;
             end
         `ADC_ABSX,`SBC_ABSX,`AND_ABSX,`ORA_ABSX,`EOR_ABSX,`CMP_ABSX,
@@ -3003,7 +3159,7 @@
                 inc_pc(24'd3);
                 radr <= absx_address;
                 wadr <= absx_address;
-                data_read(absx_address,1);
+                next_state(LOAD_MAC1);
                 mxb16 <= m16;
                 mxb32 <= m32;
                 if (!sop) begin
@@ -3011,7 +3167,6 @@
                     else if (m16) s16 <= TRUE;
                 end
                 load_what <= `LOAD_70;
-                state <= LOAD_MAC2;
                 retstate <= CALC;
             end
         `LDY_ABSX:
@@ -3020,13 +3175,12 @@
                 mxb16 <= xb16;
                 mxb32 <= xb32;
                 radr <= absx_address;
-                data_read(absx_address,1);
+                next_state(LOAD_MAC1);
                 if (!sop) begin
                     if (xb32) s32 <= TRUE;
                     else if (xb16) s16 <= TRUE;
                 end
                 load_what <= `LOAD_70;
-                state <= LOAD_MAC2;
                 retstate <= ssm ? SSM1 : IFETCH;
             end
         `STA_ABSX:
@@ -3036,13 +3190,12 @@
                 mxb32 <= m32;
                 radr <= absx_address;
                 wadr <= absx_address;
+                next_state(STORE1);
                 if (!sop) begin
                     if (m32) s32 <= TRUE;
                     else if (m16) s16 <= TRUE;
                 end
                 store_what <= `STW_ACC70;
-                data_write(absx_address,acc[7:0],1);
-                state <= STORE2;
             end
         `STZ_ABSX:
             begin
@@ -3051,13 +3204,12 @@
                 mxb32 <= m32;
                 radr <= absx_address;
                 wadr <= absx_address;
+                next_state(STORE1);
                 if (!sop) begin
                     if (m32) s32 <= TRUE;
                     else if (m16) s16 <= TRUE;
                 end
                 store_what <= `STW_Z70;
-                data_write(absx_address,8'h00,1);
-                state <= STORE2;
             end
 `ifdef SUPPORT_NEW_INSN
         // Handle xlabs,x
@@ -3067,13 +3219,12 @@
                 mxb16 <= m16;
                 mxb32 <= m32;
                 radr <= xalx_address;
-                data_read(xalx_address,1);
+                next_state(LOAD_MAC1);
                 if (!sop) begin
                     if (m32) s32 <= TRUE;
                     else if (m16) s16 <= TRUE;
                 end
                 load_what <= `LOAD_70;
-                state <= LOAD_MAC2;
                 retstate <= ssm ? SSM1 : IFETCH;
             end
         `ADC_XABSX,`SBC_XABSX,`AND_XABSX,`ORA_XABSX,`EOR_XABSX,`CMP_XABSX,
@@ -3082,7 +3233,7 @@
                 inc_pc(24'd5);
                 radr <= xalx_address;
                 wadr <= xalx_address;
-                data_read(xalx_address,1);
+                next_state(LOAD_MAC1);
                 mxb16 <= m16;
                 mxb32 <= m32;
                 if (!sop) begin
@@ -3090,7 +3241,6 @@
                     else if (m16) s16 <= TRUE;
                 end
                 load_what <= `LOAD_70;
-                state <= LOAD_MAC2;
                 retstate <= CALC;
             end
         `LDY_XABSX:
@@ -3099,13 +3249,12 @@
                 mxb16 <= xb16;
                 mxb32 <= xb32;
                 radr <= xalx_address;
-                data_read(xalx_address,1);
+                next_state(LOAD_MAC1);
                 if (!sop) begin
                     if (xb32) s32 <= TRUE;
                     else if (xb16) s16 <= TRUE;
                 end
                 load_what <= `LOAD_70;
-                state <= LOAD_MAC2;
                 retstate <= ssm ? SSM1 : IFETCH;
             end
         `STA_XABSX:
@@ -3115,13 +3264,12 @@
                 mxb32 <= m32;
                 radr <= xalx_address;
                 wadr <= xalx_address;
+                next_state(STORE1);
                 if (!sop) begin
                     if (m32) s32 <= TRUE;
                     else if (m16) s16 <= TRUE;
                 end
                 store_what <= `STW_ACC70;
-                data_write(xalx_address,acc[7:0],1);
-                state <= STORE2;
             end
         `STZ_XABSX:
             begin
@@ -3130,13 +3278,12 @@
                 mxb32 <= m32;
                 radr <= xalx_address;
                 wadr <= xalx_address;
+                next_state(STORE1);
                 if (!sop) begin
                     if (m32) s32 <= TRUE;
                     else if (m16) s16 <= TRUE;
                 end
                 store_what <= `STW_Z70;
-                data_write(xalx_address,8'h00,1);
-                state <= STORE2;
             end
 `endif
 		// Handle abs,y
@@ -3146,13 +3293,12 @@
                 mxb16 <= m16;
                 mxb32 <= m32;
                 radr <= absy_address;
-                data_read(absy_address,1);
+                next_state(LOAD_MAC1);
                 if (!sop) begin
                     if (m32) s32 <= TRUE;
                     else if (m16) s16 <= TRUE;
                 end
                 load_what <= `LOAD_70;
-                state <= LOAD_MAC2;
                 retstate <= ssm ? SSM1 : IFETCH;
                 bank_wrap <= !m832;
             end
@@ -3160,7 +3306,7 @@
             begin
                 inc_pc(24'd3);
                 radr <= absy_address;
-                data_read(absy_address,1);
+                next_state(LOAD_MAC1);
                 mxb16 <= m16;
                 mxb32 <= m32;
                 if (!sop) begin
@@ -3168,7 +3314,6 @@
                     else if (m16) s16 <= TRUE;
                 end
                 load_what <= `LOAD_70;
-                state <= LOAD_MAC2;
                 retstate <= CALC;
             end
         `LDX_ABSY:
@@ -3177,13 +3322,12 @@
                 mxb16 <= xb16;
                 mxb32 <= xb32;
                 radr <= absy_address;
-                data_read(absy_address,1);
+                next_state(LOAD_MAC1);
                 if (!sop) begin
                     if (xb32) s32 <= TRUE;
                     else if (xb16) s16 <= TRUE;
                 end
                 load_what <= `LOAD_70;
-                state <= LOAD_MAC2;
                 retstate <= ssm ? SSM1 : IFETCH;
             end
         `STA_ABSY:
@@ -3193,13 +3337,12 @@
                 mxb32 <= m32;
                 radr <= absy_address;
                 wadr <= absy_address;
+                next_state(STORE1);
                 if (!sop) begin
                     if (m32) s32 <= TRUE;
                     else if (m16) s16 <= TRUE;
                 end
                 store_what <= `STW_ACC70;
-                data_write(absy_address,acc[7:0],1);
-                state <= STORE2;
             end
 `ifdef SUPPORT_NEW_INSN
 		// Handle xlabs,y
@@ -3209,13 +3352,12 @@
                 mxb16 <= m16;
                 mxb32 <= m32;
                 radr <= xaly_address;
-                data_read(xaly_address,1);
+                next_state(LOAD_MAC1);
                 if (!sop) begin
                     if (m32) s32 <= TRUE;
                     else if (m16) s16 <= TRUE;
                 end
                 load_what <= `LOAD_70;
-                state <= LOAD_MAC2;
                 retstate <= ssm ? SSM1 : IFETCH;
             end
         `ADC_XABSY,`SBC_XABSY,`AND_XABSY,`ORA_XABSY,`EOR_XABSY,`CMP_XABSY:
@@ -3222,7 +3364,7 @@
             begin
                 inc_pc(24'd5);
                 radr <= xaly_address;
-                data_read(xaly_address,1);
+                next_state(LOAD_MAC1);
                 mxb16 <= m16;
                 mxb32 <= m32;
                 if (!sop) begin
@@ -3230,7 +3372,6 @@
                     else if (m16) s16 <= TRUE;
                 end
                 load_what <= `LOAD_70;
-                state <= LOAD_MAC2;
                 retstate <= CALC;
             end
         `LDX_XABSY:
@@ -3239,13 +3380,12 @@
                 mxb16 <= xb16;
                 mxb32 <= xb32;
                 radr <= xaly_address;
-                data_read(xaly_address,1);
+                next_state(LOAD_MAC1);
                 if (!sop) begin
                     if (xb32) s32 <= TRUE;
                     else if (xb16) s16 <= TRUE;
                 end
                 load_what <= `LOAD_70;
-                state <= LOAD_MAC2;
                 retstate <= ssm ? SSM1 : IFETCH;
             end
         `STA_XABSY:
@@ -3255,13 +3395,12 @@
                 mxb32 <= m32;
                 radr <= xaly_address;
                 wadr <= xaly_address;
+                next_state(STORE1);
                 if (!sop) begin
                     if (m32) s32 <= TRUE;
                     else if (m16) s16 <= TRUE;
                 end
                 store_what <= `STW_ACC70;
-                data_write(xaly_address,acc[7:0],1);
-                state <= STORE2;
             end
 `endif
 		// Handle al
@@ -3271,13 +3410,12 @@
                 mxb16 <= m16;
                 mxb32 <= m32;
                 radr <= al_address;
-                data_read(al_address,1);
+                next_state(LOAD_MAC1);
                 if (!sop) begin
                     if (m32) s32 <= TRUE;
                     else if (m16) s16 <= TRUE;
                 end
                 load_what <= `LOAD_70;
-                state <= LOAD_MAC2;
                 retstate <= ssm ? SSM1 : IFETCH;
             end
         `ADC_AL,`SBC_AL,`AND_AL,`ORA_AL,`EOR_AL,`CMP_AL:
@@ -3284,7 +3422,7 @@
             begin
                 inc_pc(24'd4);
                 radr <= al_address;
-                data_read(al_address,1);
+                next_state(LOAD_MAC1);
                 mxb16 <= m16;
                 mxb32 <= m32;
                 if (!sop) begin
@@ -3292,7 +3430,6 @@
                     else if (m16) s16 <= TRUE;
                 end
                 load_what <= `LOAD_70;
-                state <= LOAD_MAC2;
                 retstate <= CALC;
             end
         `STA_AL:
@@ -3302,6 +3439,7 @@
                 mxb32 <= m32;
                 radr <= al_address;
                 wadr <= al_address;
+                next_state(STORE1);
                 if (!sop) begin
                     if (m32) s32 <= TRUE;
                     else if (m16) s16 <= TRUE;
